<template>
  <el-menu-item
    :class="`${
      isCollapse ? 'is-collapse-menu' : ''
    } special-menu-tab-item mt-[25px]`"
    @click="drawer = true"
  >
    <el-icon>
      <img
        class="bg-white"
        :src="
          getAssetImage(`assets/materials/languageIcon/${defaultLanguage}.svg`)
        "
      />
    </el-icon>
    <template v-if="!isCollapse" #title>
      <div class="ml-[29px] flex justify-between w-full items-center">
        <span>{{ defaultLanguageForDisplay }}</span>
        <font-awesome-icon
          icon="play"
          class="text-[5px] absolute right-[10px]"
        />
      </div>
    </template>
  </el-menu-item>
  <div>
    <el-drawer
      v-model="drawer"
      :title="$t('language')"
      :with-header="true"
      :show-close="true"
    >
      <el-menu default-active="2" class="el-menu-vertical-demo">
        <el-menu-item class="active language-menu-item">
          <el-icon class="language-icon"
            ><img
              :src="
                getAssetImage(
                  `assets/materials/languageIcon/${defaultLanguage}.svg`
                )
              "
          /></el-icon>
          <template #title>
            <div class="ml-[10px] flex justify-between w-full items-center">
              <span>{{ defaultLanguageForDisplay }}</span>
              <font-awesome-icon
                icon="check"
                class="text-[15px] absolute right-[10px] checked-lang"
              />
            </div>
          </template>
        </el-menu-item>
        <el-menu-item
          v-for="lang in languages"
          :key="lang"
          class="language-menu-item"
          @click="switchLanguage(String(lang.ISO))"
        >
          <el-icon
            :class="`language-icon-${lang.ISO} language-icon mr-[15px]`"
            style="margin-right: 15px"
          >
            <img
              :src="
                getAssetImage(`assets/materials/languageIcon/${lang.ISO}.svg`)
              "
            />
          </el-icon>
          <template #title>{{ lang.LanguageLocalName }}</template>
        </el-menu-item>
      </el-menu>
    </el-drawer>
  </div>
</template>
<script lang="ts" setup>
import { useLanguageComponent } from "@/composables/useTheme";
import commonHelper from "@/utils/commonHelper";

defineProps({
  defaultLanguage: {
    type: String,
    required: true,
  },
  defaultLanguageForDisplay: {
    type: String,
    required: true,
  },
  isCollapse: {
    type: Boolean,
    required: true,
  },
});

const drawer = ref(false);

const { languages, switchLanguage } = useLanguageComponent();
const { getAssetImage } = commonHelper;
</script>
<style scoped>
.el-menu-item {
  height: 50px;
  color: var(--text2);
}
:deep(.el-menu-vertical-demo) {
  background: var(--background2);
  border-right: unset;
}
.language-icon {
  background: var(--text5);
  width: 24px;
  height: 24px;
}
.language-icon-zh_TW,
.language-icon-my_MM {
  background: unset;
}
.el-menu-vertical-demo .el-menu-item {
  height: 40px;
  margin-bottom: 16px;
  border-radius: 8px;
}
.language-menu-item {
  width: 100%;
}
.el-menu-item.active {
  box-shadow: var(--box-shadow-inset);
}
.el-menu-item:hover {
  background: var(--background-body);
  box-shadow: var(--box-shadow);
}
.active.language-menu-item .checked-lang {
  color: var(--primary-fallback);
}
:deep(.el-drawer__header span) {
  font-size: 2.15rem;
  font-weight: 700;
}
</style>
